Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingMultiset<E>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingCollection<E>
              com.google.common.collect.ForwardingMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Iterable<E>, Collection<E>

    public abstract class ForwardingMultiset<E>

extends ForwardingCollection<E>
implements Multiset<E>

A multiset which forwards all its method calls to another multiset. Subclasses should override one or more methods to modify the behavior of the backing multiset as desired per the decorator pattern.

Author:
  Kevin Bourrillion
See Also:
  `ForwardingObject`

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Constructor Summary
`ForwardingMultiset()`

Method Summary
`int` | `add(E element, int occurrences)` Adds a number of occurrences of an element to this multiset.
`int` | `count(Object element)` Returns the number of occurrences of an element in this multiset (the count of the element).
`protected abstract Multiset<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`int` | `hashCode()` Returns a hash code value for the object.
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`int` | `setCount(E element, int count)` Adds or removes the necessary occurrences of an element such that the element attains the desired count.
`boolean` | `setCount(E element, int oldCount, int newCount)` Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count.

Methods inherited from class com.google.common.collect.ForwardingCollection
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multiset
`add, contains, containsAll, iterator, remove, removeAll, retainAll, toString`

Methods inherited from interface java.util.Collection
`addAll, clear, isEmpty, size, toArray, toArray`

Constructor Detail

### ForwardingMultiset

    public ForwardingMultiset()

Method Detail

### delegate

    protected abstract Multiset<E> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingCollection<E>`

### count

    public int count(Object element)

  Description copied from interface: `Multiset`
  Returns the number of occurrences of an element in this multiset (the count of the element). Note that for an `Object.equals(java.lang.Object)`-based multiset, this gives the same result as `Collections.frequency(java.util.Collection, java.lang.Object)` (which would presumably perform more poorly).

  Note: the utility method `Iterables.frequency(java.lang.Iterable, java.lang.Object)` generalizes this operation; it correctly delegates to this method when dealing with a multiset, but it can also accept any other iterable type.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to count occurrences of
  Returns:
    the number of occurrences of the element in this multiset; possibly zero but never negative

### add

    public int add(E element,
                   int occurrences)

  Description copied from interface: `Multiset`
  Adds a number of occurrences of an element to this multiset. Note that if `occurrences == 1`, this method has the identical effect to `Multiset.add(Object)`. This method is functionally equivalent (except in the case of overflow) to the call `addAll(Collections.nCopies(element, occurrences))`, which would presumably perform much more poorly.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add occurrences of; may be `null` only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### remove

    public int remove(Object element,
                      int occurrences)

  Description copied from interface: `Multiset`
  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed. Note that if `occurrences == 1`, this is functionally equivalent to the call `remove(element)`.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### elementSet

    public Set<E> elementSet()

  Description copied from interface: `Multiset`
  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Description copied from interface: `Multiset`
  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from class: `java.lang.Object`
  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Description copied from class: `java.lang.Object`
  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### setCount

    public int setCount(E element,
                        int count)

  Description copied from interface: `Multiset`
  Adds or removes the necessary occurrences of an element such that the element attains the desired count.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero

### setCount

    public boolean setCount(E element,
                            int oldCount,
                            int newCount)

  Description copied from interface: `Multiset`
  Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count. If the current count is not `oldCount`, no change is made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD